/Java-Google-Foobar-Running-With-Bunnies

An application of Floyd-Warshall's Algorithm, Johnson's Algorithm for weight readjustment, Bellman-Ford's Algorithm and DFS coupled with memoization.

Primary LanguageJava

Running with bunnies

Problem Statement

You and your rescued bunny prisoners need to get out of this collapsing death trap of a space station - and fast! Unfortunately, some of the bunnies have been weakened by their long imprisonment and can't run very fast. Their friends are trying to help them, but this escape would go a lot faster if you also pitched in. The defensive bulkhead doors have begun to close, and if you don't make it through in time, you'll be trapped! You need to grab as many bunnies as you can and get through the bulkheads before they close.

The time it takes to move from your starting point to all of the bunnies and to the bulkhead will be given to you in a square matrix of integers. Each row will tell you the time it takes to get to the start, first bunny, second bunny, ..., last bunny, and the bulkhead in that order. The order of the rows follows the same pattern (start, each bunny, bulkhead). The bunnies can jump into your arms, so picking them up is instantaneous, and arriving at the bulkhead at the same time as it seals still allows for a successful, if dramatic, escape. (Don't worry, any bunnies you don't pick up will be able to escape with you since they no longer have to carry the ones you did pick up.) You can revisit different spots if you wish, and moving to the bulkhead doesn't mean you have to immediately leave - you can move to and from the bulkhead to pick up additional bunnies if time permits.

In addition to spending time traveling between bunnies, some paths interact with the space station's security checkpoints and add time back to the clock. Adding time to the clock will delay the closing of the bulkhead doors, and if the time goes back up to 0 or a positive number after the doors have already closed, it triggers the bulkhead to reopen. Therefore, it might be possible to walk in a circle and keep gaining time: that is, each time a path is traversed, the same amount of time is used or added.

Write a function of the form solution(times, time_limit) to calculate the most bunnies you can pick up and which bunnies they are, while still escaping through the bulkhead before the doors close for good. If there are multiple sets of bunnies of the same size, return the set of bunnies with the lowest prisoner IDs (as indexes) in sorted order. The bunnies are represented as a sorted list by prisoner ID, with the first bunny being 0. There are at most 5 bunnies, and time_limit is a non-negative integer that is at most 999.

For instance, in the case of [ [0, 2, 2, 2, -1], # 0 = Start [9, 0, 2, 2, -1], # 1 = Bunny 0 [9, 3, 0, 2, -1], # 2 = Bunny 1 [9, 3, 2, 0, -1], # 3 = Bunny 2 [9, 3, 2, 2, 0], # 4 = Bulkhead ] and a time limit of 1, the five inner array rows designate the starting point, bunny 0, bunny 1, bunny 2, and the bulkhead door exit respectively. You could take the path: Start End Delta Time Status

  • 0 - 1 Bulkhead initially open 0 4 -1 2 4 2 2 0 2 4 -1 1 4 3 2 -1 Bulkhead closes 3 4 -1 0 Bulkhead reopens; you and the bunnies exit

With this solution, you would pick up bunnies 1 and 2. This is the best combination for this space station hallway, so the answer is [1, 2].

Solution

The solution to this problem is rather complex. Since this is a NP problem, you have to use brute force with a lot of optimization. For example, if there is a negative cycle in the graph, then you might as well traverse it for inifinity and have an infinite time limit thus allowing you to rescue all bunnies. Thus, we initially use Floyd Warshall's Algorithm to find a negative cycle. If none exists, we then use the infamous weight readjustment technique of the Johnson's Algorithm to convert all weights to a postive value. We then use DFS and augment it with memoization to optimize it. Note, in case you use Python, you might make use of the @cache and @lru_cache decorator in the functools module of Python which saves you a lot of memoization code. The brute force part of this problem is very similar to Leetcode 1575 : Count All Possible Routes

Here is the solution to Leetcode 1575.

class Solution:
    def countRoutes(self, locations: List[int], start: int, finish: int, fuel: int) -> int:
        # Note why the constraint of the array inetegrs being distinct is really important 
        # [1, 2, 3, 4, 3, ..] 
        # Possible answers are infinite [..., 2, ..], [..., 2, 4, ...], [..., 2, 4, 2, ..] ...
        @cache 
        def getNumberOfPaths(node, target, rem_fuel):
            if node == target and rem_fuel == 0:
                return 1
            if rem_fuel <= 0:
                return 0
            
            ans = 0
            for i in range(self.N):
                if i == node:
                    continue
                ans += getNumberOfPaths(i, target, rem_fuel - abs(self.arr[node] - self.arr[i]))
                ans  = int(ans % self.modulus)
                
            if node == target:
                ans += 1
            return ans 
        
        self.arr = locations
        self.N = len(locations)
        self.modulus = 1e9 + 7
        
        return getNumberOfPaths(start, finish, fuel)